local StaticPopup_ShowOrig = StaticPopup_Show
local frameNum = 1
local BINDINGS = {
    ["LeftButton"]   = "BUTTON1",    -- just in case someone uses left and right buttons
    ["RightButton"]  = "BUTTON2",    -- (with modifiers probably) to bind abilities and whatnot
    ["MiddleButton"] = "BUTTON3",
    ["Button4"]      = "BUTTON4",
    ["Button5"]      = "BUTTON5"
}

CreateFrame("Frame"):SetScript("OnUpdate", function()
    while frameNum <= WorldFrame:GetNumChildren() do    -- children do not change order from my observations so we don't need to scan all of them every time
        local frame = ({WorldFrame:GetChildren()})[frameNum]
        if frame:GetObjectType() == "Button" then       -- there seems to be no other buttons in WorldFrame rather than nameplates
            frame:RegisterForClicks("LeftButtonDown", "RightButtonDown", "MiddleButtonDown", "Button4Down", "Button5Down")
            frame:SetScript("OnClick", function()
                local bindingAction = GetBindingAction((IsAltKeyDown()     and "ALT-"   or "")..
                                                       (IsControlKeyDown() and "CTRL-"  or "")..
                                                       (IsShiftKeyDown()   and "SHIFT-" or "")..
                                                       BINDINGS[arg1])
                StaticPopup_Show = function(a1, a2, a3, a4) return a1 ~= "ADDON_ACTION_FORBIDDEN" and StaticPopup_ShowOrig(a1, a2, a3, a4) or nil end
                RunBinding(bindingAction)          -- key down    | binding action may be protected like MOVEANDSTEER, therefore we are blocking
                RunBinding(bindingAction, "up")    -- key up      | "%s has been blocked from an action..." popup when using RunBinding
                StaticPopup_Show = StaticPopup_ShowOrig
            end)
        end
        frameNum = frameNum + 1
    end
end)
